// Generated by LiveScript 1.5.0
var child_process, any, ObservableProcess, os, DockerHelper, slice$ = [].slice;
child_process = require('child_process');
any = require('prelude-ls').any;
ObservableProcess = require('observable-process');
os = require('os');
DockerHelper = (function(){
  DockerHelper.displayName = 'DockerHelper';
  var prototype = DockerHelper.prototype, constructor = DockerHelper;
  DockerHelper.containerExists = function(container){
    var this$ = this;
    return function(it){
      return it.includes(container);
    }(
    function(it){
      return it.split('\n');
    }(
    function(it){
      return it.toString();
    }(
    child_process.execSync('docker ps -a --format {{.Names}}'))));
  };
  DockerHelper.containerIsRunning = function(containerName){
    var this$ = this;
    return any(function(it){
      return it.includes(containerName + "/Up");
    })(
    function(it){
      return it.split(os.EOL);
    }(
    function(it){
      return it.toString();
    }(
    child_process.execSync('docker ps --format {{.Names}}/{{.Status}}'))));
  };
  DockerHelper.ensureContainerIsRunning = function(container, done){
    switch (false) {
    case !DockerHelper.containerIsRunning(container.containerName):
      return done();
    case !DockerHelper.containerExists(container.containerName):
      return DockerHelper.startContainer(container, done);
    default:
      return DockerHelper.runImage(container, done);
    }
  };
  DockerHelper.getBuildCommand = function(image, buildFlags){
    return "docker build -t " + image.author + "/" + image.name + " " + (buildFlags ? buildFlags : "") + " .";
  };
  DockerHelper.getConfig = function(image){
    var this$ = this;
    return function(it){
      return it.toString();
    }(
    child_process.execSync("docker run --rm=true " + image + " cat service.yml", 'utf8'));
  };
  DockerHelper.getDockerIp = function(container){
    var this$ = this;
    if (DockerHelper.containerExists(container)) {
      return function(it){
        return it.trim();
      }(
      function(it){
        return it.toString();
      }(
      child_process.execSync("docker inspect --format '{{ .NetworkSettings.IPAddress }}' " + container, "utf8")));
    }
  };
  DockerHelper.getDockerImages = function(){
    return child_process.execSync('docker images');
  };
  DockerHelper.getPullCommand = function(image){
    return "docker pull " + image.author + "/" + image.name + (image.version ? ":" + image.version : "");
  };
  DockerHelper.removeContainer = function(container){
    if (DockerHelper.containerExists(container)) {
      return child_process.execSync("docker rm -f " + container);
    }
  };
  DockerHelper.runImage = function(container, done){
    var isStarted, x$, process;
    isStarted = false;
    x$ = process = new ObservableProcess("docker run " + (container.volume || '') + " " + (container.port || '') + " --name=" + container.containerName + " " + container.dependencyName + (container.version ? ':' + container.version : void 8), {
      stdout: false,
      stderr: false
    });
    x$.on('ended', function(exitCode, killed){
      switch (false) {
      case !(exitCode > 0 && !killed):
        if (/container name ".*" is already in use by container/.test(process.fullOutput())) {
          return DockerHelper.ensureContainerIsRunning(container, done);
        }
        console.log(DockerHelper._printLastLines(process.fullOutput(), 20));
        if (!isStarted) {
          return done("Dependency " + container.containerName + " failed to run, shutting down");
        }
      }
    });
    x$.wait(container.onlineText, function(){
      if (!isStarted) {
        isStarted = true;
        return done();
      }
    });
    return x$;
  };
  DockerHelper.startContainer = function(container, done){
    var x$;
    x$ = new ObservableProcess("docker start -a " + container.containerName, {
      stdout: false,
      stderr: false
    });
    x$.on('ended', function(exitCode, killed){
      switch (false) {
      case !(exitCode > 0 && !killed):
        return done("Dependency " + container.containerName + " failed to start, shutting down");
      }
    });
    x$.wait(container.onlineText, done);
    return x$;
  };
  DockerHelper.imageExists = function(image){
    var this$ = this;
    return function(it){
      return it.includes(image.author + "/" + image.name);
    }(
    child_process.execSync("docker images " + image.author + "/" + image.name + (image.version ? ":" + image.version : ""), "utf-8"));
  };
  DockerHelper.removeAllContainers = function(){
    var allContainers, this$ = this;
    allContainers = function(it){
      return it.toString();
    }(
    child_process.execSync('docker ps -aq'));
    if (allContainers) {
      return child_process.execSync('docker rm -f $(docker ps -aq)');
    }
  };
  DockerHelper._printLastLines = function(text, numberOfLines){
    return slice$.call(text.split('\n'), -numberOfLines).join('\n');
  };
  function DockerHelper(){}
  return DockerHelper;
}());
module.exports = DockerHelper;